/** @file counter_coverage.cpp
 * This file contains implementation of the coverage class.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#include <counter_coverage.h>
#include <counter_model.h>

namespace cpptesk {
namespace examples {
namespace counter {

CounterCoverage::Counter_BitSet CounterCoverage::cov_BitSet(void) const
{
    switch(counter.isIface1Ready()) {
        case 0:  return CounterCoverage::Counter_BitSet::I0;
        case 1:  return CounterCoverage::Counter_BitSet::I1;
        default: assert(false);
    }
}

void CounterCoverage::out_cov(void) {
      coverageTracker << CounterCoverage::cov_BitSet();
}

}}}
